###########################################
#     GIVE CREDIT WHERE CREDIT IS DUE     #
#                                         #
#          T4ILS AND JETJET               #
###########################################




import json, sys, time, operator
from ..util.dialogs import link_dialog
from concurrent.futures import ThreadPoolExecutor
import xbmc, xbmcaddon, xbmcgui, xbmcplugin
from resources.lib.plugin import Plugin
from datetime import datetime, timedelta
import calendar, inputstreamhelper
from sportjetextractors import extractors, extractor
from resources.lib.plugin import run_hook

import operator

CACHE_TIME = 0  # change to wanted cache time in seconds
SEARCH_IGNORE = ["Full Match TV", "Playoffsstream", "NFLStream", "Sportsurge", "Bilasport", "Topstreams"]

addon_fanart = xbmcaddon.Addon().getAddonInfo('fanart')
addon_icon = xbmcaddon.Addon().getAddonInfo('icon')
user_agent = 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.84 Safari/537.36'

class sportjetextractors(Plugin):
    name = "sportjetextractors"
    priority = 100

    def get_metadata(self, item):
        if "guidedata" in item:
            ts = time.time()
            utc_offset = (datetime.fromtimestamp(ts) - datetime.utcfromtimestamp(ts)).total_seconds()
            current_time = ts
            label = "N/A"
            for programme in item["guidedata"]:
                if current_time >= programme["starttime"] and current_time <= programme["starttime"] + programme["duration"]:
                    start_time = datetime.utcfromtimestamp(programme["starttime"] + utc_offset)
                    end_time = datetime.utcfromtimestamp(programme["starttime"] + programme["duration"] + utc_offset)
                    label = f"{start_time.strftime('%I:%M %p')} - {end_time.strftime('%I:%M %p')}: {programme['label']}"
                    break
            item["list_item"].setLabel(item["list_item"].getLabel() + f"\n{label}")

    def process_item(self, item):
        if "sportjetextractors" in item:
            link = item.get("sportjetextractors", "")
            thumbnail = item.get("thumbnail", "")
            fanart = item.get("fanart", "")
            icon = item.get("icon", "")
            if not isinstance(link, list):
                item["link"] = "sportjetextractors/games/" + link if link != "search" else "sportjetextractors/search"
                item["is_dir"] = True
                list_item = xbmcgui.ListItem(item.get("title", item.get("name", "")), offscreen=True)
                list_item.setArt({"thumb": thumbnail, "fanart": fanart})
                item["list_item"] = list_item
                return item

        
    def play_video(self, video: str):
        item = json.loads(video)
        link = item.get("sportjetextractors")
        title = item.get("title")
        thumbnail = item.get("thumbnail", "")
        if link:
            if isinstance(link, list):   
                link = link_dialog(link)  
                if link == None: return True

                if link.startswith("links://"):
                    links = extractor.get_links(link.replace("links://", ""))
                    link = link_dialog(links)
                    if link == None: return True
            link = extractor.extract_m3u8(link)
            if link == None:
                xbmcgui.Dialog().ok("sportjetextractors Error", "sportjetextractors could not find a playable link for this URL.")
                return True
            elif link == False: return True
            if link.startswith("inputstream://"):
                mpd_split = link.split("===")
                mpd_url = mpd_split[0].replace("inputstream://", "")
                license_key = mpd_split[1]
                is_helper = inputstreamhelper.Helper('mpd', drm='widevine')
                if not is_helper.check_inputstream():
                    sys.exit()
                liz = xbmcgui.ListItem(item.get("title", mpd_url), path=mpd_url)
                if int(xbmc.getInfoLabel('System.BuildVersion').split('.')[0]) >= 19: liz.setProperty('inputstream', 'inputstream.adaptive')
                else: liz.setProperty('inputstreamaddon', 'inputstream.adaptive')
                liz.setProperty('inputstream.adaptive.manifest_type', 'mpd')

                if license_key != '':
                    liz.setProperty('inputstream.adaptive.license_type', 'com.widevine.alpha')
                    liz.setProperty('inputstream.adaptive.license_key', license_key)
                liz.setMimeType('application/dash+xml')
                liz.setContentLookup(False)
                xbmcplugin.setResolvedUrl(int(sys.argv[1]), True, liz)
                xbmc.Player().play(mpd_url, listitem=liz)
            elif link.startswith("ffmpegdirect://"):
                m3u8_url = link.replace("ffmpegdirect://", "")
                liz = xbmcgui.ListItem(item.get("title", m3u8_url), path=m3u8_url)
                
                liz.setInfo('video', {'Title': title})
                liz.setArt({'thumb': thumbnail, 'icon': thumbnail})
                
                if int(xbmc.getInfoLabel('System.BuildVersion').split('.')[0]) >= 19: liz.setProperty('inputstream', 'inputstream.ffmpegdirect')
                else: liz.setProperty('inputstreamaddon', 'inputstream.ffmpegdirect')
                liz.setProperty('inputstream.ffmpegdirect.is_realtime_stream', 'true')
                liz.setProperty('inputstream.ffmpegdirect.stream_mode', 'timeshift')
                liz.setProperty('inputstream.ffmpegdirect.manifest_type', 'hls')
                liz.setMimeType('application/x-mpegURL')
                xbmcplugin.setResolvedUrl(int(sys.argv[1]), True, liz)
                xbmc.Player().play(m3u8_url, listitem=liz)
            else:
                liz = xbmcgui.ListItem(title)               
                liz.setInfo('video', {'Title': title})
                liz.setArt({'thumb': thumbnail, 'icon': thumbnail})
                xbmc.Player().play(link,liz)
            return True
        
            
    def routes(self, plugin):
        @plugin.route("/sportjetextractors/games/<path:site>")
        def get_games(site):
            for module in extractors.__all__:
                if hasattr(module, "site_name") and hasattr(module, "get_games") and site == module.site_name:
                    games = module.get_games()
                    games.sort(key = operator.itemgetter('league', 'title', 'time' ), reverse = False)
                    jen_list = []
                    for game in games:
                        jen_data = {
                            "title": "[COLORdodgerblue]%s[COLORwhite] |[B][I] %s[/B][/I] [COLORred]%s[/COLOR]" % (game["league"].replace("'", ""), game["title"], format_time(game["time"])),
                            "thumbnail": game["icon"],
                            "fanart": game["icon"],
                            "summary": game["title"],
                            "sportjetextractors": game["links"],
                            "type": "item"
                        }
                        # jen_data = {
                            #:"title": "[COLORdodgerblue]%s[COLORwhite] |[B][I] %s[/B][/I]\n  [COLORred]%s[/COLOR]" % (game["league"].replace("'", ""), game["title"], format_time(game["time"])),
                            # "thumbnail": game["icon"],
                            # "fanart": game["icon"],
                            # "summary": game["title"],
                            # "sportjetextractors": game["links"],
                            # "type": "item"
                        # }
                        jen_list.append(jen_data)
                    jen_list = [run_hook("process_item", item) for item in jen_list]
                    jen_list = [run_hook("get_metadata", item, return_item_on_failure=True) for item in jen_list]
                    run_hook("display_list", jen_list)
        
        @plugin.route("/sportjetextractors/search")
        def search_games():
            query = xbmcgui.Dialog().input("Search game")
            games = []
            with ThreadPoolExecutor() as executor:
                running_tasks = []
                for module in extractors.__all__:
                    if hasattr(module, "site_name") and hasattr(module, "get_games") and not module.site_name.endswith("Highlights") and module.site_name not in SEARCH_IGNORE:
                        if module.site_name not in SEARCH_IGNORE: running_tasks.append(executor.submit(lambda: [module.site_name, module.get_games()]))
                for running_task in running_tasks:
                    try:
                        site_games = running_task.result()[1]
                        site_name = running_task.result()[0]
                        for game in site_games:
                            if query.lower() not in game["title"].lower() and query.lower() not in game["league"].lower(): continue
                            jen_data = {
                                "title": "[COLORdodgerblue]%s[COLORwhite] |[B][I] %s[/B][/I]\n  [COLORred]%s | %s[/COLOR]" % (game["league"].replace("'", ""), game["title"], site_name, format_time(game["time"])),
                                "thumbnail": game["icon"],
                                "fanart": game["icon"],
                                "summary": game["title"],
                                "sportjetextractors": game["links"],
                                "type": "item"
                            }
                            games.append(jen_data)
                    except Exception as e:
                        continue
            games = [run_hook("process_item", item) for item in games]
            games = [run_hook("get_metadata", item, return_item_on_failure=True) for item in games]
            run_hook("display_list", games)

def format_time(date):
    return utc_to_local(date).strftime("%m/%d %I:%M %p") if date != "" else ""

# https://stackoverflow.com/questions/4563272/convert-a-python-utc-datetime-to-a-local-datetime-using-only-python-standard-lib
def utc_to_local(utc_dt):
    timestamp = calendar.timegm(utc_dt.timetuple())
    local_dt = datetime.fromtimestamp(timestamp)
    assert utc_dt.resolution >= timedelta(microseconds=1)
    return local_dt.replace(microsecond=utc_dt.microsecond)


